//------------------------------------------------------------------------
// UNIT           : E950DrvI.pas
// CONTENTS       : TE950Driver ActiveX control interface
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0
// AUTHORS         : Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov, Marco Cocco
// STATUS         : Freeware
//------------------------------------------------------------------------
//
// Copyright (c) 1996-98 by Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov. All rights reseved.
// Copyright (c) 1996-98 by Marco Cocco. All rights reseved.
// Copyright (c) 1996-98 by d3k Software Company. All rights reseved.
//
// NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
//   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY
//                          THE USE OF THIS SOFTWARE.
//

unit E950DriverI;

interface

uses
  Windows, ActiveX, Classes, Controls, Graphics, Menus, Forms, StdCtrls,
  ComServ, StdVCL, AXCtrls, E950DriverXC_TLB, E950Drv1, ExtCtrls;

type
  TE950DriverX = class(TActiveXControl, IE950DriverX)
  private
    { Private declarations }
    FDelphiControl: TE950Driver;
    FEvents: IE950DriverXEvents;
    procedure AfterCloseCheckEvent(E950: TE950Driver);
    procedure AfterCloseDokEvent(E950: TE950Driver);
    procedure AfterCloseNCheckEvent(E950: TE950Driver);
    procedure AfterCloseNDokEvent(E950: TE950Driver);
    procedure AfterOpenCheckEvent(E950: TE950Driver);
    procedure AfterOpenDokEvent(E950: TE950Driver);
    procedure AfterOpenNCheckEvent(E950: TE950Driver);
    procedure AfterOpenNDokEvent(E950: TE950Driver);
    procedure AfterPrnStrCheckEvent(E950: TE950Driver);
    procedure AfterPrnStrDokEvent(E950: TE950Driver);
    procedure AfterPrnSubTotalCheckEvent(E950: TE950Driver);
    procedure AfterPrnSubTotalDokEvent(E950: TE950Driver);
    procedure AfterPrnTotalCheckEvent(E950: TE950Driver);
    procedure AfterPrnTotalDokEvent(E950: TE950Driver);
    procedure AfterPrnTxtCheckEvent(E950: TE950Driver);
    procedure AfterPrnTxtDokEvent(E950: TE950Driver);
    procedure AfterPrnTxtNCheckEvent(E950: TE950Driver);
    procedure AfterPrnTxtNDokEvent(E950: TE950Driver);
    procedure BeforeCloseCheckEvent(E950: TE950Driver);
    procedure BeforeCloseDokEvent(E950: TE950Driver);
    procedure BeforeCloseNCheckEvent(E950: TE950Driver);
    procedure BeforeCloseNDokEvent(E950: TE950Driver);
    procedure BeforeOpenCheckEvent(E950: TE950Driver);
    procedure BeforeOpenDokEvent(E950: TE950Driver);
    procedure BeforeOpenNCheckEvent(E950: TE950Driver);
    procedure BeforeOpenNDokEvent(E950: TE950Driver);
    procedure BeforePrnStrCheckEvent(E950: TE950Driver);
    procedure BeforePrnStrDokEvent(E950: TE950Driver);
    procedure BeforePrnSubTotalCheckEvent(E950: TE950Driver);
    procedure BeforePrnSubTotalDokEvent(E950: TE950Driver);
    procedure BeforePrnTotalCheckEvent(E950: TE950Driver);
    procedure BeforePrnTotalDokEvent(E950: TE950Driver);
    procedure BeforePrnTxtCheckEvent(E950: TE950Driver);
    procedure BeforePrnTxtDokEvent(E950: TE950Driver);
    procedure BeforePrnTxtNCheckEvent(E950: TE950Driver);
    procedure BeforePrnTxtNDokEvent(E950: TE950Driver);
    procedure ErrorEvent(Error: string);
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure InitializeControl; override;
    function ChangePassword(const PasswordOld,
      PasswordNew: WideString): WideString; safecall;
    function CheckTotal(InSum: Currency; IndxCurr, IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; safecall;
    function ClassNameIs(const Name: WideString): WordBool; safecall;
    function CloseCheck: Integer; safecall;
    function CloseFDok: Integer; safecall;
    function ConditionSLIP(CountFreeLine, Pos1, Pos2: Integer): Integer;
      safecall;
    function Connect: WordBool; safecall;
    function Connected: WordBool; safecall;
    function CountRX: Integer; safecall;
    function DrawTextBiDiModeFlags(Flags: Integer): Integer; safecall;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function FlushBuffers(inBuf, outBuf: WordBool): WordBool; safecall;
    function Get_BaudRate: TxBaudRate; safecall;
    function Get_BaudRateValue: Integer; safecall;
    function Get_BiDiMode: TxBiDiMode; safecall;
    function Get_CashireName: WideString; safecall;
    function Get_CheckLineStatus: WordBool; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DataBits: TxDataBits; safecall;
    function Get_DateTimeFR: TDateTime; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_EnableDTROnOpen: WordBool; safecall;
    function Get_ErrorStr: WideString; safecall;
    function Get_HwFlow: TxHwFlowControl; safecall;
    function Get_InBufSize: Integer; safecall;
    function Get_InputTimeout: Integer; safecall;
    function Get_InspPassword: WideString; safecall;
    function Get_OutBufSize: Integer; safecall;
    function Get_OutputTimeout: Integer; safecall;
    function Get_Parity: TxParity; safecall;
    function Get_Password: WideString; safecall;
    function Get_PollingDelay: Integer; safecall;
    function Get_Port: TxPortNumber; safecall;
    function Get_PortName: WideString; safecall;
    function Get_StopBits: TxStopBits; safecall;
    function Get_SwFlow: TxSwFlowControl; safecall;
    function Get_TrainingState: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function GetBlockWorkMem(SetOf, LenBlock: Integer): WideString; safecall;
    function GetControlsAlignment: TxAlignment; safecall;
    function GetDefineDesc(NumTbl, NumDesc: Integer): WideString; safecall;
    function IsPolling: WordBool; safecall;
    function IsRightToLeft: WordBool; safecall;
    function OutFreeSpace: Smallint; safecall;
    function TotalFDok(InSum: Currency; IndxCurr, IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; safecall;
    function UseRightToLeftAlignment: WordBool; safecall;
    function UseRightToLeftReading: WordBool; safecall;
    function UseRightToLeftScrollBar: WordBool; safecall;
    procedure Certification; safecall;
    procedure CloseNDok; safecall;
    procedure CloseNFCheck; safecall;
    procedure CloseSmena(Fix: WordBool; var NumClose, CountFCheckComplect,
      CountFCheckNotComplect, CountFDokComplect, CountFDokNotComplect,
      CountFDokAnulComplect, CountCheckDokService: Integer; var SumSale,
      SumMargin, SumDiscount, SumContainer: Currency;
      var CountCheckDokBack: Integer; var SumSaleBack, SumMarginBack,
      SumDiscountBack, SumContainerBack: Currency;
      var CountCheckDokPayment: Integer; var SumPension, SumTranslation,
      SumComission: Currency; var CountCheckDokPaymentBack: Integer;
      var SumPensionBack, SumTranslationBack, SumComissionBack: Currency;
      var CountCheckDokCashe: Integer; var SumCashe: Currency;
      var CountCheckDokCasheBack: Integer; var SumCasheBack: Currency);
      safecall;
    procedure ContinuePolling; safecall;
    procedure CutNFCheck; safecall;
    procedure Disconnect; safecall;
    procedure EjectDok; safecall;
    procedure FeedLineBoth(CountLine: Integer); safecall;
    procedure FeedLineCheck(CountLine: Integer); safecall;
    procedure FeedLineDok(CountLine: Integer); safecall;
    procedure FeedLineLog(CountLine: Integer); safecall;
    procedure Fiskalization; safecall;
    procedure FlipChildren(AllLevels: WordBool); safecall;
    procedure FontPrn(Font: Integer); safecall;
    procedure GetDmpFiskal(SendToPrint: WordBool; var RN, UserFR,
      PasswordFiskal, PasswordUser: WideString; var DateReg: TDateTime);
      safecall;
    procedure GetDmpSertificate(SendToPrint: WordBool; var SN: WideString;
      var PosPoint, Devaluations, CurrDef, TypePrn: Integer;
      var PasswordFiskal, PasswordUser: WideString;
      var DateSer: TDateTime); safecall;
    procedure GetFMemSize(var AllMem, UsesMem: Integer); safecall;
    procedure GetStatusRegistrator(var LastFDok: Integer;
      var FirstDokDateTime: TDateTime; var LastClose,
      CountFiskals: Integer; var VersionROM: WideString;
      var Lastdate: TDateTime; var SumMoney: Currency); safecall;
    procedure InitiateAction; safecall;
    procedure LoadFiskal(const RN, UserFR, PasswordFiskal,
      PasswordUser: WideString; DateReg: Double); safecall;
    procedure LoadSertificate(const SN: WideString; PosPoint, Devaluations,
      CurrDef, TypePrn: Integer; const PasswordFiskal,
      PasswordUser: WideString; DateSer: TDateTime); safecall;
    procedure OpenCheck(TypeCheck: TxTypeCheck; IndxCurr: Integer); safecall;
    procedure OpenFDok(TDok: TxTypeDok; IndxDescCurr, CountFreeLine,
      PosHeader1, PosDesc, LenDesc, PosDefineDesc, LenDefineDesc,
      PosDescStr, LenDescStr, PosDefineStr, LenDefgineDescStr, PosSum,
      LenSum, PosDescTotal, LenDescTotal, PosDefineTotal, LenDefineToTal,
      PosSumTotal, LenSumTotal, PosHeader2: Integer); safecall;
    procedure OpenNDok(IndxDesc: Integer; const DefIndxDesc: WideString;
      EmptyStr, PosHeader1, PosHeader2: Integer); safecall;
    procedure OpenNFCheck(IndxNCheck: Integer;
      const DefineDescNCheck: WideString); safecall;
    procedure PausePolling; safecall;
    procedure PrintDefineFDok(IndxDesc: Integer; const DefineFDok: WideString);
      safecall;
    procedure PrintFiskalStr(IndxDescStr: Integer;
      const DefineDescStr: WideString; Count: Double; IndxDescUM: Integer;
      Price: Currency; IndxDescCurr: Integer; const TypeStr: WideString;
      ProcMargine, ProcDiscount: Double); safecall;
    procedure PrintFiskalTxt(IndxDesc: Integer; const FiskalTxt: WideString);
      safecall;
    procedure PrintNDokStr(const Str: WideString); safecall;
    procedure PrintNFText(const Str: WideString); safecall;
    procedure PrintStrFDok(IndxDescStr: Integer;
      const DefineDescStr: WideString; Count: Double; IndxDescUM: Integer;
      Price: Currency; IndxDescCurr: Integer; const TypeStr: WideString;
      ProcMargine, ProcDiscount: Double); safecall;
    procedure PrintTestPrinter; safecall;
    procedure ReportDiag; safecall;
    procedure ReportOfDates(BeginDate, EndDate: Double; ItogOnly: WordBool);
      safecall;
    procedure ReportOfSmena(BeginSmena, EndSmena: Integer; ItogOnly: WordBool);
      safecall;
    procedure ResetRegistrator; safecall;
    procedure Set_BaudRate(Value: TxBaudRate); safecall;
    procedure Set_BaudRateValue(Value: Integer); safecall;
    procedure Set_BiDiMode(Value: TxBiDiMode); safecall;
    procedure Set_CashireName(const Value: WideString); safecall;
    procedure Set_CheckLineStatus(Value: WordBool); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DataBits(Value: TxDataBits); safecall;
    procedure Set_DateTimeFR(Value: TDateTime); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_EnableDTROnOpen(Value: WordBool); safecall;
    procedure Set_HwFlow(Value: TxHwFlowControl); safecall;
    procedure Set_InBufSize(Value: Integer); safecall;
    procedure Set_InputTimeout(Value: Integer); safecall;
    procedure Set_InspPassword(const Value: WideString); safecall;
    procedure Set_OutBufSize(Value: Integer); safecall;
    procedure Set_OutputTimeout(Value: Integer); safecall;
    procedure Set_Parity(Value: TxParity); safecall;
    procedure Set_Password(const Value: WideString); safecall;
    procedure Set_PollingDelay(Value: Integer); safecall;
    procedure Set_Port(Value: TxPortNumber); safecall;
    procedure Set_PortName(const Value: WideString); safecall;
    procedure Set_StopBits(Value: TxStopBits); safecall;
    procedure Set_SwFlow(Value: TxSwFlowControl); safecall;
    procedure Set_TrainingState(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure SetBlockWorkMem(SetOf: Integer; const InfoBlock: WideString);
      safecall;
    procedure SetDefineDesc(NumTbl, NumDesc: Integer;
      const DefineDesc: WideString); safecall;
    procedure SubTotal(PrintSubTotal, PrintCheck: WordBool;
      IndxDescSubTotal: Integer; const DefineSubTotal: WideString;
      IndxDescCurr, ProcMargine, ProcDiscount: Integer;
      var TypeCheck: TxTypeCheck; var CountLine: Integer; var TotalSale,
      TotalMargine, TotalDiscount, TotalContainer, InCash: Currency);
      safecall;
    procedure SubTotalFDok(PrintDok: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndDescCurr: Integer; ProcMargine,
      ProcDiscount: Double; var TDok: TxTypeDok; var CountLine: Integer;
      var TotalSale, TotalMargine, TotalDiscount, TotalContainer,
      InCashe: Currency); safecall;
    procedure TestFBlock(PrintDok: WordBool; var CountBlock, CountSuccBlock,
      CountErrorBlock, CountFreeBlock: Integer); safecall;
    procedure ToggleDTR(onOff: WordBool); safecall;
    procedure ToggleRTS(onOff: WordBool); safecall;
    function LR(const Param: WideString): WideString; safecall;
    function Get_HeaderCheck(ind: Integer): WideString; safecall;
    procedure Set_HeaderCheck(ind: Integer; const newval: WideString);
      safecall;
    function GetHeaderCheck(idx: Integer): WideString; safecall;
    procedure SetHeaderCheck(idx: Integer; const newval: WideString); safecall;
    function Get_DefineDesc(numtbl, numdesc: Integer): WideString; safecall;
    procedure Set_DefineDesc(numtbl, numdesc: Integer; DefineDesc: WideString);
      safecall;
    function Get_CashBox(BoxNo: Integer): WordBool; safecall;
    procedure Set_CashBox(BoxNo: Integer; Value: WordBool); safecall;
    procedure OpenCashBox(Ano: Integer); safecall;
  end;

implementation

uses ComObj;

{ TE950DriverX }

procedure TE950DriverX.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_E950DriverXPage); }
end;

procedure TE950DriverX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IE950DriverXEvents;
end;

procedure TE950DriverX.InitializeControl;
begin
  FDelphiControl := Control as TE950Driver;
  FDelphiControl.AfterCloseCheck := AfterCloseCheckEvent;
  FDelphiControl.AfterCloseDok := AfterCloseDokEvent;
  FDelphiControl.AfterCloseNCheck := AfterCloseNCheckEvent;
  FDelphiControl.AfterCloseNDok := AfterCloseNDokEvent;
  FDelphiControl.AfterOpenCheck := AfterOpenCheckEvent;
  FDelphiControl.AfterOpenDok := AfterOpenDokEvent;
  FDelphiControl.AfterOpenNCheck := AfterOpenNCheckEvent;
  FDelphiControl.AfterOpenNDok := AfterOpenNDokEvent;
  FDelphiControl.AfterPrnStrCheck := AfterPrnStrCheckEvent;
  FDelphiControl.AfterPrnStrDok := AfterPrnStrDokEvent;
  FDelphiControl.AfterPrnSubTotalCheck := AfterPrnSubTotalCheckEvent;
  FDelphiControl.AfterPrnSubTotalDok := AfterPrnSubTotalDokEvent;
  FDelphiControl.AfterPrnTotalCheck := AfterPrnTotalCheckEvent;
  FDelphiControl.AfterPrnTotalDok := AfterPrnTotalDokEvent;
  FDelphiControl.AfterPrnTxtCheck := AfterPrnTxtCheckEvent;
  FDelphiControl.AfterPrnTxtDok := AfterPrnTxtDokEvent;
  FDelphiControl.AfterPrnTxtNCheck := AfterPrnTxtNCheckEvent;
  FDelphiControl.AfterPrnTxtNDok := AfterPrnTxtNDokEvent;
  FDelphiControl.BeforeCloseCheck := BeforeCloseCheckEvent;
  FDelphiControl.BeforeCloseDok := BeforeCloseDokEvent;
  FDelphiControl.BeforeCloseNCheck := BeforeCloseNCheckEvent;
  FDelphiControl.BeforeCloseNDok := BeforeCloseNDokEvent;
  FDelphiControl.BeforeOpenCheck := BeforeOpenCheckEvent;
  FDelphiControl.BeforeOpenDok := BeforeOpenDokEvent;
  FDelphiControl.BeforeOpenNCheck := BeforeOpenNCheckEvent;
  FDelphiControl.BeforeOpenNDok := BeforeOpenNDokEvent;
  FDelphiControl.BeforePrnStrCheck := BeforePrnStrCheckEvent;
  FDelphiControl.BeforePrnStrDok := BeforePrnStrDokEvent;
  FDelphiControl.BeforePrnSubTotalCheck := BeforePrnSubTotalCheckEvent;
  FDelphiControl.BeforePrnSubTotalDok := BeforePrnSubTotalDokEvent;
  FDelphiControl.BeforePrnTotalCheck := BeforePrnTotalCheckEvent;
  FDelphiControl.BeforePrnTotalDok := BeforePrnTotalDokEvent;
  FDelphiControl.BeforePrnTxtCheck := BeforePrnTxtCheckEvent;
  FDelphiControl.BeforePrnTxtDok := BeforePrnTxtDokEvent;
  FDelphiControl.BeforePrnTxtNCheck := BeforePrnTxtNCheckEvent;
  FDelphiControl.BeforePrnTxtNDok := BeforePrnTxtNDokEvent;
  FDelphiControl.OnError := ErrorEvent;
end;

function TE950DriverX.ChangePassword(const PasswordOld,
  PasswordNew: WideString): WideString;
begin
  Result := FDelphiControl.ChangePassword(PasswordOld, PasswordNew);
end;

function TE950DriverX.CheckTotal(InSum: Currency; IndxCurr,
  IndxOpl: Integer; const DefOpl: WideString; Tender: WordBool): Currency;
begin
  Result := FDelphiControl.CheckTotal(InSum, IndxCurr, IndxOpl, DefOpl, Tender);
end;

function TE950DriverX.ClassNameIs(const Name: WideString): WordBool;
begin
  Result := FDelphiControl.ClassNameIs(Name);
end;

function TE950DriverX.CloseCheck: Integer;
begin
  Result := FDelphiControl.CloseCheck;
end;

function TE950DriverX.CloseFDok: Integer;
begin
  Result := FDelphiControl.CloseFDok;
end;

function TE950DriverX.ConditionSLIP(CountFreeLine, Pos1,
  Pos2: Integer): Integer;
begin
  Result := FDelphiControl.ConditionSLIP(CountFreeLine, Pos1, Pos2);
end;

function TE950DriverX.Connect: WordBool;
begin
  Result := FDelphiControl.Connect;
end;

function TE950DriverX.Connected: WordBool;
begin
  Result := FDelphiControl.Connected;
end;

function TE950DriverX.CountRX: Integer;
begin
  Result := FDelphiControl.CountRX;
end;

function TE950DriverX.DrawTextBiDiModeFlags(Flags: Integer): Integer;
begin
  Result := FDelphiControl.DrawTextBiDiModeFlags(Flags);
end;

function TE950DriverX.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := FDelphiControl.DrawTextBiDiModeFlagsReadingOnly;
end;

function TE950DriverX.FlushBuffers(inBuf, outBuf: WordBool): WordBool;
begin
  Result := FDelphiControl.FlushBuffers(inBuf, outBuf);
end;

function TE950DriverX.Get_BaudRate: TxBaudRate;
begin
  Result := Ord(FDelphiControl.BaudRate);
end;

function TE950DriverX.Get_BaudRateValue: Integer;
begin
  Result := Integer(FDelphiControl.BaudRateValue);
end;

function TE950DriverX.Get_BiDiMode: TxBiDiMode;
begin
  Result := Ord(FDelphiControl.BiDiMode);
end;

function TE950DriverX.Get_CashireName: WideString;
begin
  Result := FDelphiControl.CashireName;
end;

function TE950DriverX.Get_CheckLineStatus: WordBool;
begin
  Result := FDelphiControl.CheckLineStatus;
end;

function TE950DriverX.Get_Cursor: Smallint;
begin
  Result := Smallint(FDelphiControl.Cursor);
end;

function TE950DriverX.Get_DataBits: TxDataBits;
begin
  Result := Ord(FDelphiControl.DataBits);
end;

function TE950DriverX.Get_DateTimeFR: TDateTime;
begin
  Result := FDelphiControl.DateTimeFR;
end;

function TE950DriverX.Get_DoubleBuffered: WordBool;
begin
  Result := FDelphiControl.DoubleBuffered;
end;

function TE950DriverX.Get_Enabled: WordBool;
begin
  Result := FDelphiControl.Enabled;
end;

function TE950DriverX.Get_EnableDTROnOpen: WordBool;
begin
  Result := FDelphiControl.EnableDTROnOpen;
end;

function TE950DriverX.Get_ErrorStr: WideString;
begin
  Result := WideString(FDelphiControl.ErrorStr);
end;

function TE950DriverX.Get_HwFlow: TxHwFlowControl;
begin
  Result := Ord(FDelphiControl.HwFlow);
end;

function TE950DriverX.Get_InBufSize: Integer;
begin
  Result := Integer(FDelphiControl.InBufSize);
end;

function TE950DriverX.Get_InputTimeout: Integer;
begin
  Result := Integer(FDelphiControl.InputTimeout);
end;

function TE950DriverX.Get_InspPassword: WideString;
begin
  Result := WideString(FDelphiControl.InspPassword);
end;

function TE950DriverX.Get_OutBufSize: Integer;
begin
  Result := Integer(FDelphiControl.OutBufSize);
end;

function TE950DriverX.Get_OutputTimeout: Integer;
begin
  Result := Smallint(FDelphiControl.OutputTimeout);
end;

function TE950DriverX.Get_Parity: TxParity;
begin
  Result := Ord(FDelphiControl.Parity);
end;

function TE950DriverX.Get_Password: WideString;
begin
  Result := WideString(FDelphiControl.Password);
end;

function TE950DriverX.Get_PollingDelay: Integer;
begin
  Result := Smallint(FDelphiControl.PollingDelay);
end;

function TE950DriverX.Get_Port: TxPortNumber;
begin
  Result := Ord(FDelphiControl.Port);
end;

function TE950DriverX.Get_PortName: WideString;
begin
  Result := WideString(FDelphiControl.PortName);
end;

function TE950DriverX.Get_StopBits: TxStopBits;
begin
  Result := Ord(FDelphiControl.StopBits);
end;

function TE950DriverX.Get_SwFlow: TxSwFlowControl;
begin
  Result := Ord(FDelphiControl.SwFlow);
end;

function TE950DriverX.Get_TrainingState: WordBool;
begin
  Result := FDelphiControl.TrainingState;
end;

function TE950DriverX.Get_Visible: WordBool;
begin
  Result := FDelphiControl.Visible;
end;

function TE950DriverX.GetBlockWorkMem(SetOf,
  LenBlock: Integer): WideString;
begin
  Result := FDelphiControl.GetBlockWorkMem(SetOf, LenBlock);
end;

function TE950DriverX.GetControlsAlignment: TxAlignment;
begin
  Result := TxAlignment(FDelphiControl.GetControlsAlignment);
end;

function TE950DriverX.GetDefineDesc(NumTbl, NumDesc: Integer): WideString;
begin
  Result := FDelphiControl.DefineDesc[NumTbl, NumDesc];
end;

procedure TE950DriverX.SetDefineDesc(NumTbl, NumDesc: Integer; const DefineDesc: WideString);
begin
  FDelphiControl.DefineDesc[NumTbl, NumDesc] := DefineDesc;
end;

function TE950DriverX.IsPolling: WordBool;
begin
  Result := FDelphiControl.IsPolling;
end;

function TE950DriverX.IsRightToLeft: WordBool;
begin
  Result := FDelphiControl.IsRightToLeft;
end;

function TE950DriverX.OutFreeSpace: Smallint;
begin
  Result := FDelphiControl.OutFreeSpace;
end;

function TE950DriverX.TotalFDok(InSum: Currency; IndxCurr,
  IndxOpl: Integer; const DefOpl: WideString; Tender: WordBool): Currency;
begin
  Result := FDelphiControl.TotalFDok(InSum, IndxCurr, IndxOpl, DefOpl, Tender);
end;

function TE950DriverX.UseRightToLeftAlignment: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftAlignment;
end;

function TE950DriverX.UseRightToLeftReading: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftReading;
end;

function TE950DriverX.UseRightToLeftScrollBar: WordBool;
begin
  Result := FDelphiControl.UseRightToLeftScrollBar;
end;

procedure TE950DriverX.Certification;
begin
  FDelphiControl.Certification;
end;

procedure TE950DriverX.CloseNDok;
begin
  FDelphiControl.CloseNDok;
end;

procedure TE950DriverX.CloseNFCheck;
begin
  FDelphiControl.CloseNFCheck;
end;

procedure TE950DriverX.CloseSmena(Fix: WordBool; var NumClose,
  CountFCheckComplect, CountFCheckNotComplect, CountFDokComplect,
  CountFDokNotComplect, CountFDokAnulComplect,
  CountCheckDokService: Integer; var SumSale, SumMargin, SumDiscount,
  SumContainer: Currency; var CountCheckDokBack: Integer; var SumSaleBack,
  SumMarginBack, SumDiscountBack, SumContainerBack: Currency;
  var CountCheckDokPayment: Integer; var SumPension, SumTranslation,
  SumComission: Currency; var CountCheckDokPaymentBack: Integer;
  var SumPensionBack, SumTranslationBack, SumComissionBack: Currency;
  var CountCheckDokCashe: Integer; var SumCashe: Currency;
  var CountCheckDokCasheBack: Integer; var SumCasheBack: Currency);
begin
  FDelphiControl.CloseSmena(Fix, NumClose,
    CountFCheckComplect, CountFCheckNotComplect, CountFDokComplect,
    CountFDokNotComplect, CountFDokAnulComplect,
    CountCheckDokService, SumSale, SumMargin, SumDiscount,
    SumContainer, CountCheckDokBack, SumSaleBack,
    SumMarginBack, SumDiscountBack, SumContainerBack,
    CountCheckDokPayment, SumPension, SumTranslation,
    SumComission, CountCheckDokPaymentBack,
    SumPensionBack, SumTranslationBack, SumComissionBack,
    CountCheckDokCashe, SumCashe,
    CountCheckDokCasheBack, SumCasheBack);
end;

procedure TE950DriverX.ContinuePolling;
begin
  FDelphiControl.ContinuePolling;
end;

procedure TE950DriverX.CutNFCheck;
begin
  FDelphiControl.CutNFCheck;
end;

procedure TE950DriverX.Disconnect;
begin
  FDelphiControl.Disconnect;
end;

procedure TE950DriverX.EjectDok;
begin
  FDelphiControl.EjectDok;
end;

procedure TE950DriverX.FeedLineBoth(CountLine: Integer);
begin
  FDelphiControl.FeedLineBoth(CountLine);
end;

procedure TE950DriverX.FeedLineCheck(CountLine: Integer);
begin
  FDelphiControl.FeedLineCheck(CountLine);
end;

procedure TE950DriverX.FeedLineDok(CountLine: Integer);
begin
  FDelphiControl.FeedLineDok(CountLine);
end;

procedure TE950DriverX.FeedLineLog(CountLine: Integer);
begin
  FDelphiControl.FeedLineLog(CountLine);
end;

procedure TE950DriverX.Fiskalization;
begin
  FDelphiControl.Fiskalization;
end;

procedure TE950DriverX.FlipChildren(AllLevels: WordBool);
begin
  FDelphiControl.FlipChildren(AllLevels);
end;

procedure TE950DriverX.FontPrn(Font: Integer);
begin
  FDelphiControl.FontPrn(Font);
end;

procedure TE950DriverX.GetDmpFiskal(SendToPrint: WordBool; var RN, UserFR,
  PasswordFiskal, PasswordUser: WideString; var DateReg: TDateTime);
begin
  FDelphiControl.GetDmpFiskal(SendToPrint, RN, UserFR,
    PasswordFiskal, PasswordUser, DateReg);
end;

procedure TE950DriverX.GetDmpSertificate(SendToPrint: WordBool;
  var SN: WideString; var PosPoint, Devaluations, CurrDef,
  TypePrn: Integer; var PasswordFiskal, PasswordUser: WideString;
  var DateSer: TDateTime);
begin
  FDelphiControl.GetDmpSertificate(SendToPrint,
    SN, PosPoint, Devaluations, CurrDef, TypePrn,
    PasswordFiskal, PasswordUser, DateSer);
end;

procedure TE950DriverX.GetFMemSize(var AllMem, UsesMem: Integer);
begin
  FDelphiControl.GetFMemSize(AllMem, UsesMem);
end;

procedure TE950DriverX.InitiateAction;
begin
  FDelphiControl.InitiateAction;
end;

procedure TE950DriverX.LoadFiskal(const RN, UserFR, PasswordFiskal,
  PasswordUser: WideString; DateReg: Double);
begin
  FDelphiControl.LoadFiskal(RN, UserFR, PasswordFiskal, PasswordUser, DateReg);
end;

procedure TE950DriverX.LoadSertificate(const SN: WideString; PosPoint,
  Devaluations, CurrDef, TypePrn: Integer; const PasswordFiskal,
  PasswordUser: WideString; DateSer: TDateTime);
begin
  FDelphiControl.LoadSertificate(SN, PosPoint, Devaluations, CurrDef, TypePrn, PasswordFiskal, PasswordUser, DateSer);
end;

procedure TE950DriverX.OpenCheck(TypeCheck: TxTypeCheck;
  IndxCurr: Integer);
begin
  FDelphiControl.OpenCheck(TxTypeCheck(TypeCheck), IndxCurr);
end;

procedure TE950DriverX.OpenFDok(TDok: TxTypeDok; IndxDescCurr,
  CountFreeLine, PosHeader1, PosDesc, LenDesc, PosDefineDesc,
  LenDefineDesc, PosDescStr, LenDescStr, PosDefineStr, LenDefgineDescStr,
  PosSum, LenSum, PosDescTotal, LenDescTotal, PosDefineTotal,
  LenDefineToTal, PosSumTotal, LenSumTotal, PosHeader2: Integer);
begin
  FDelphiControl.OpenFDok(TDok, IndxDescCurr, CountFreeLine, PosHeader1, PosDesc, LenDesc, PosDefineDesc, LenDefineDesc, PosDescStr, LenDescStr, PosDefineStr, LenDefgineDescStr, PosSum, LenSum, PosDescTotal, LenDescTotal, PosDefineTotal, LenDefineToTal, PosSumTotal, LenSumTotal, PosHeader2);
end;

procedure TE950DriverX.OpenNDok(IndxDesc: Integer;
  const DefIndxDesc: WideString; EmptyStr, PosHeader1,
  PosHeader2: Integer);
begin
  FDelphiControl.OpenNDok(IndxDesc, DefIndxDesc, EmptyStr, PosHeader1, PosHeader2);
end;

procedure TE950DriverX.OpenNFCheck(IndxNCheck: Integer;
  const DefineDescNCheck: WideString);
begin
  FDelphiControl.OpenNFCheck(IndxNCheck, DefineDescNCheck);
end;

procedure TE950DriverX.PausePolling;
begin
  FDelphiControl.PausePolling;
end;

procedure TE950DriverX.PrintDefineFDok(IndxDesc: Integer;
  const DefineFDok: WideString);
begin
  FDelphiControl.PrintDefineFDok(IndxDesc, DefineFDok);
end;

procedure TE950DriverX.PrintFiskalStr(IndxDescStr: Integer;
  const DefineDescStr: WideString; Count: Double; IndxDescUM: Integer;
  Price: Currency; IndxDescCurr: Integer; const TypeStr: WideString;
  ProcMargine, ProcDiscount: Double);
begin
  FDelphiControl.PrintFiskalStr(IndxDescStr, DefineDescStr, Count, IndxDescUM, Price, IndxDescCurr, TypeStr, ProcMargine, ProcDiscount);
end;

procedure TE950DriverX.PrintFiskalTxt(IndxDesc: Integer;
  const FiskalTxt: WideString);
begin
  FDelphiControl.PrintFiskalTxt(IndxDesc, FiskalTxt);
end;

procedure TE950DriverX.PrintNDokStr(const Str: WideString);
begin
  FDelphiControl.PrintNDokStr(Str);
end;

procedure TE950DriverX.PrintNFText(const Str: WideString);
begin
  FDelphiControl.PrintNFText(Str);
end;

procedure TE950DriverX.PrintStrFDok(IndxDescStr: Integer;
  const DefineDescStr: WideString; Count: Double; IndxDescUM: Integer;
  Price: Currency; IndxDescCurr: Integer; const TypeStr: WideString;
  ProcMargine, ProcDiscount: Double);
var
  TypeStrChar: WideChar;
begin
  if Length(TypeStr) <= 0
    then TypeStrChar := #32
  else TypeStrChar := TypeStr[1];
  FDelphiControl.PrintStrFDok(IndxDescStr, DefineDescStr, Count, IndxDescUM, Price, IndxDescCurr, TypeStrChar, ProcMargine, ProcDiscount);
end;

procedure TE950DriverX.PrintTestPrinter;
begin
  FDelphiControl.PrintTestPrinter;
end;

procedure TE950DriverX.ReportDiag;
begin
  FDelphiControl.ReportDiag;
end;

procedure TE950DriverX.ReportOfDates(BeginDate, EndDate: Double;
  ItogOnly: WordBool);
begin
  FDelphiControl.ReportOfDates(BeginDate, EndDate, ItogOnly);
end;

procedure TE950DriverX.ReportOfSmena(BeginSmena, EndSmena: Integer;
  ItogOnly: WordBool);
begin
  FDelphiControl.ReportOfSmena(BeginSmena, EndSmena, ItogOnly);
end;

procedure TE950DriverX.ResetRegistrator;
begin
  FDelphiControl.ResetRegistrator;
end;

procedure TE950DriverX.Set_BaudRate(Value: TxBaudRate);
begin
  FDelphiControl.BaudRate := TBaudRate(Value);
end;

procedure TE950DriverX.Set_BaudRateValue(Value: Integer);
begin
  FDelphiControl.BaudRateValue := Cardinal(Value);
end;

procedure TE950DriverX.Set_BiDiMode(Value: TxBiDiMode);
begin
  FDelphiControl.BiDiMode := TBiDiMode(Value);
end;

procedure TE950DriverX.Set_CashireName(const Value: WideString);
begin
  FDelphiControl.CashireName := Value;
end;

procedure TE950DriverX.Set_CheckLineStatus(Value: WordBool);
begin
  FDelphiControl.CheckLineStatus := Value;
end;

procedure TE950DriverX.Set_Cursor(Value: Smallint);
begin
  FDelphiControl.Cursor := TCursor(Value);
end;

procedure TE950DriverX.Set_DataBits(Value: TxDataBits);
begin
  FDelphiControl.DataBits := TDataBits(Value);
end;

procedure TE950DriverX.Set_DateTimeFR(Value: TDateTime);
begin
  FDelphiControl.DateTimeFR := Value;
end;

procedure TE950DriverX.Set_DoubleBuffered(Value: WordBool);
begin
  FDelphiControl.DoubleBuffered := Value;
end;

procedure TE950DriverX.Set_Enabled(Value: WordBool);
begin
  FDelphiControl.Enabled := Value;
end;

procedure TE950DriverX.Set_EnableDTROnOpen(Value: WordBool);
begin
  FDelphiControl.EnableDTROnOpen := Value;
end;

procedure TE950DriverX.Set_HwFlow(Value: TxHwFlowControl);
begin
  FDelphiControl.HwFlow := THwFlowControl(Value);
end;

procedure TE950DriverX.Set_InBufSize(Value: Integer);
begin
  FDelphiControl.InBufSize := Cardinal(Value);
end;

procedure TE950DriverX.Set_InputTimeout(Value: Integer);
begin
  FDelphiControl.InputTimeout := Cardinal(Value);
end;

procedure TE950DriverX.Set_InspPassword(const Value: WideString);
begin
  FDelphiControl.InspPassword := Value;
end;

procedure TE950DriverX.Set_OutBufSize(Value: Integer);
begin
  FDelphiControl.OutBufSize := Cardinal(Value);
end;

procedure TE950DriverX.Set_OutputTimeout(Value: Integer);
begin
  FDelphiControl.OutputTimeout := Word(Value);
end;

procedure TE950DriverX.Set_Parity(Value: TxParity);
begin
  FDelphiControl.Parity := TParity(Value);
end;

procedure TE950DriverX.Set_Password(const Value: WideString);
begin
  FDelphiControl.Password := Value;
end;

procedure TE950DriverX.Set_PollingDelay(Value: Integer);
begin
  FDelphiControl.PollingDelay := Word(Value);
end;

procedure TE950DriverX.Set_Port(Value: TxPortNumber);
begin
  FDelphiControl.Port := TPortNumber(Value);
end;

procedure TE950DriverX.Set_PortName(const Value: WideString);
begin
  FDelphiControl.PortName := Value;
end;

procedure TE950DriverX.Set_StopBits(Value: TxStopBits);
begin
  FDelphiControl.StopBits := TStopBits(Value);
end;

procedure TE950DriverX.Set_SwFlow(Value: TxSwFlowControl);
begin
  FDelphiControl.SwFlow := TSwFlowControl(Value);
end;

procedure TE950DriverX.Set_TrainingState(Value: WordBool);
begin
  FDelphiControl.TrainingState := Value;
end;

procedure TE950DriverX.Set_Visible(Value: WordBool);
begin
  FDelphiControl.Visible := Value;
end;

procedure TE950DriverX.SetBlockWorkMem(SetOf: Integer;
  const InfoBlock: WideString);
begin
  FDelphiControl.SetBlockWorkMem(SetOf, InfoBlock);
end;

procedure TE950DriverX.SubTotal(PrintSubTotal, PrintCheck: WordBool;
  IndxDescSubTotal: Integer; const DefineSubTotal: WideString;
  IndxDescCurr, ProcMargine, ProcDiscount: Integer;
  var TypeCheck: TxTypeCheck; var CountLine: Integer; var TotalSale,
  TotalMargine, TotalDiscount, TotalContainer, InCash: Currency);
begin
  FDelphiControl.SubTotal(PrintSubTotal, PrintCheck,
    IndxDescSubTotal, DefineSubTotal,
    IndxDescCurr, ProcMargine, ProcDiscount,
    TypeCheck, CountLine, TotalSale,
    TotalMargine, TotalDiscount, TotalContainer, InCash);
end;

procedure TE950DriverX.SubTotalFDok(PrintDok: WordBool;
  IndxDescSubTotal: Integer; const DefineSubTotal: WideString;
  IndDescCurr: Integer; ProcMargine, ProcDiscount: Double;
  var TDok: TxTypeDok; var CountLine: Integer; var TotalSale, TotalMargine,
  TotalDiscount, TotalContainer, InCashe: Currency);
begin
  FDelphiControl.SubTotalFDok(PrintDok,
    IndxDescSubTotal, DefineSubTotal,
    IndDescCurr, ProcMargine, ProcDiscount, TDok,
    CountLine, TotalSale, TotalMargine, TotalDiscount,
    TotalContainer, InCashe);
end;

procedure TE950DriverX.TestFBlock(PrintDok: WordBool; var CountBlock,
  CountSuccBlock, CountErrorBlock, CountFreeBlock: Integer);
begin
  FDelphiControl.TestFBlock(PrintDok, CountBlock, CountSuccBlock,
    CountErrorBlock, CountFreeBlock);
end;

procedure TE950DriverX.ToggleDTR(onOff: WordBool);
begin
  FDelphiControl.ToggleDTR(onOff);
end;

procedure TE950DriverX.ToggleRTS(onOff: WordBool);
begin
  FDelphiControl.ToggleRTS(onOff);
end;

procedure TE950DriverX.AfterCloseCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterCloseCheck;
end;

procedure TE950DriverX.AfterCloseDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterCloseDok;
end;

procedure TE950DriverX.AfterCloseNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterCloseNCheck;
end;

procedure TE950DriverX.AfterCloseNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterCloseNDok;
end;

procedure TE950DriverX.AfterOpenCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterOpenCheck;
end;

procedure TE950DriverX.AfterOpenDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterOpenDok;
end;

procedure TE950DriverX.AfterOpenNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterOpenNCheck;
end;

procedure TE950DriverX.AfterOpenNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterOpenNDok;
end;

procedure TE950DriverX.AfterPrnStrCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnStrCheck;
end;

procedure TE950DriverX.AfterPrnStrDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnStrDok;
end;

procedure TE950DriverX.AfterPrnSubTotalCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnSubTotalCheck;
end;

procedure TE950DriverX.AfterPrnSubTotalDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnSubTotalDok;
end;

procedure TE950DriverX.AfterPrnTotalCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTotalCheck;
end;

procedure TE950DriverX.AfterPrnTotalDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTotalDok;
end;

procedure TE950DriverX.AfterPrnTxtCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTxtCheck;
end;

procedure TE950DriverX.AfterPrnTxtDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTxtDok;
end;

procedure TE950DriverX.AfterPrnTxtNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTxtNCheck;
end;

procedure TE950DriverX.AfterPrnTxtNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.AfterPrnTxtNDok;
end;

procedure TE950DriverX.BeforeCloseCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeCloseCheck;
end;

procedure TE950DriverX.BeforeCloseDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeCloseDok;
end;

procedure TE950DriverX.BeforeCloseNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeCloseNCheck;
end;

procedure TE950DriverX.BeforeCloseNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeCloseNDok;
end;

procedure TE950DriverX.BeforeOpenCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeOpenCheck;
end;

procedure TE950DriverX.BeforeOpenDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeOpenDok;
end;

procedure TE950DriverX.BeforeOpenNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeOpenNCheck;
end;

procedure TE950DriverX.BeforeOpenNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforeOpenNDok;
end;

procedure TE950DriverX.BeforePrnStrCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnStrCheck;
end;

procedure TE950DriverX.BeforePrnStrDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnStrDok;
end;

procedure TE950DriverX.BeforePrnSubTotalCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnSubTotalCheck;
end;

procedure TE950DriverX.BeforePrnSubTotalDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnSubTotalDok;
end;

procedure TE950DriverX.BeforePrnTotalCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTotalCheck;
end;

procedure TE950DriverX.BeforePrnTotalDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTotalDok;
end;

procedure TE950DriverX.BeforePrnTxtCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTxtCheck;
end;

procedure TE950DriverX.BeforePrnTxtDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTxtDok;
end;

procedure TE950DriverX.BeforePrnTxtNCheckEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTxtNCheck;
end;

procedure TE950DriverX.BeforePrnTxtNDokEvent(E950: TE950Driver);
begin
  if FEvents <> nil then FEvents.BeforePrnTxtNDok;
end;

procedure TE950DriverX.ErrorEvent(Error: string);
begin
  if FEvents <> nil then FEvents.OnError;
end;

procedure TE950DriverX.GetStatusRegistrator(var LastFDok: Integer;
  var FirstDokDateTime: TDateTime; var LastClose, CountFiskals: Integer;
  var VersionROM: WideString; var Lastdate: TDateTime;
  var SumMoney: Currency);
begin
  FDelphiControl.GetStatusRegistrator(LastFDok, FirstDokDateTime, LastClose, CountFiskals, VersionROM, Lastdate, SumMoney);
end;

function TE950DriverX.LR(const Param: WideString): WideString;
begin
  Result := FDelphiControl.LastResult[Param];
end;

function TE950DriverX.Get_HeaderCheck(ind: Integer): WideString;
begin
  Result := FDelphiControl.HeaderCheck[ind];
end;

procedure TE950DriverX.Set_HeaderCheck(ind: Integer;
  const newval: WideString);
begin
  FDelphiControl.HeaderCheck[ind] := newval;
end;

function TE950DriverX.GetHeaderCheck(idx: Integer): WideString;
begin
  Result := FDelphiControl.HeaderCheck[idx];
end;

procedure TE950DriverX.SetHeaderCheck(idx: Integer;
  const newval: WideString);
begin
  FDelphiControl.HeaderCheck[idx] := newval;
end;

function TE950DriverX.Get_DefineDesc(numtbl, numdesc: Integer): WideString;
begin
  Result := FDelphiControl.DefineDesc[NumTbl, NumDesc];
end;

procedure TE950DriverX.Set_DefineDesc(numtbl, numdesc: Integer; DefineDesc: WideString);
begin
  FDelphiControl.DefineDesc[NumTbl, NumDesc] := DefineDesc;
end;

function TE950DriverX.Get_CashBox(BoxNo: Integer): WordBool;
begin
  Result := FDelphiControl.CashBoxOpened[BoxNo];
end;

procedure TE950DriverX.Set_CashBox(BoxNo: Integer; Value: WordBool);
begin
  FDelphiControl.CashBoxOpened[BoxNo] := Value;
end;

procedure TE950DriverX.OpenCashBox(Ano: Integer);
begin
  FDelphiControl.CashBoxOpened[ANo] := True;
end;

initialization
  TActiveXControlFactory.Create(
    ComServer,
    TE950DriverX,
    TE950Driver,
    Class_E950DriverX,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.

