//------------------------------------------------------------------------
// UNIT           : E950Const.pas
// CONTENTS       : TE950Driver component constants
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0
// AUTHORS         : Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov, Marco Cocco
// STATUS         : Freeware
//------------------------------------------------------------------------
//
// Copyright (c) 1996-98 by Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov. All rights reseved.
// Copyright (c) 1996-98 by Marco Cocco. All rights reseved.
// Copyright (c) 1996-98 by d3k Software Company. All rights reseved.
//
// NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
//   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY
//                          THE USE OF THIS SOFTWARE.
//

unit E950Const;

interface

resourcestring

  SErrorFSumFMem = '    ';
  SErrorFSumWorkMeme = '    ';
  SErrorFLowBat = ' ';
  SErrorFUnknown = ' ';
  SErrorFField = '  ';
  SErrorFStat = '    ';
  SErrorFOver = ' ';
  SErrorFFullMem = '  ';
  SErrorFFullMem1 = '   ';
  SErrorFRegistred = '  ';
  SErrorFSertificed = '  ';
  SErrorFPassDate = '   ';
  SErrorFFCheckIsOpen = '    ';
  SErrorFCheckIsOpen = ' ';
  SErrorFDokIsOpen = '  ';

  SErrorPBusy = ' ';
  SErrorPSelect = ' ';
  SErrorP = '/ ';
  SErrorPOff = '   RS-232 ';
  SErrorPEndGL = '  ';
  SErrorPEndCL = '  ';
  SErrorPFullBuff = '   COM- ';
  SErrorPEmptyBuff = '  ';
  SErrorPPDokPresent = '  ';
  SErrorPDokMove = '    ';
  SErrorPDokSmall = '   ';
  SErrorPNoCG = '    ';
  SErrorNotAnswer = '   Epson 950';
  SErrorInvalidCashBox = '   (0..1)';

  SErrorNak = ' Epson 950    ';
type
  //  
  {
    TStatusRegistr = record
      LastFDok: Integer;
      FirstDokDate: TDateTime;
      FirstDokTime: TDateTime;
      LastClose: Integer;
      CountFiskals: Integer;
      VersionROM: WideString;
      Lastdate: TDateTime;
      SumMoney: Currency;
    end;
    PStatusRegistr = ^TStatusRegistr;
  }

  //  
  TSertificate = record
    SN: string[16];
    PosPoint: Byte;
    Devaluations: Byte;
    CurrDef: Byte;
    TypePrn: Byte;
    PasswordFiskal: string[8];
    PasswordUser: string[8];
    DateSer: TDateTime;
  end;
  PSertificate = ^TSertificate;

  //
  TFiskal = record
    RN: string[16];
    UserFR: string[16];
    PasswordFiskal: string[8];
    PasswordUser: string[8];
    DateReg: TDateTime;
  end;
  PFiskal = ^TFiskal;

  // 
  TFMemSize = record
    AllMem: Word;
    UsesMem: Word;
  end;
  PFMemSize = ^TFMemSize;

  TSmenaClose = record
    NumClose: Word;
    CountFCheckComplect: Word;
    CountFCheckNotComplect: Word;
    CountFDokComplect: Word;
    CountFDokNotComplect: Word;
    CountFDokAnulComplect: Word;
    CountCheckDokService: Word;
    SumSale: Cardinal;
    SumMargin: Cardinal;
    SumDiscount: Cardinal;
    SumContainer: Cardinal;
    CountCheckDokBack: Word;
    SumSaleBack: Cardinal;
    SumMarginBack: Cardinal;
    SumDiscountBack: Cardinal;
    SumContainerBack: Cardinal;
    CountCheckDokPayment: Word;
    SumPension: Cardinal;
    SumTranslation: Cardinal;
    SumComission: Cardinal;
    CountCheckDokPaymentBack: Word;
    SumPensionBack: Cardinal;
    SumTranslationBack: Cardinal;
    SumComissionBack: Cardinal;
    CountCheckDokCashe: Word;
    SumCashe: Cardinal;
    CountCheckDokCasheBack: Word;
    SumCasheBack: Cardinal;
  end;
  PSmenaClose = ^TSmenaClose;

  //  
  TTypeCheck = (Service, ServiceBack, Payment, PaymentBack, Cashe, CasheBack);
  PTypeCheck = ^TTypeCheck;

  //  
  TFiskalStr = record
    IndxDiscStr: Word;
    DefineDiscStr: string[20];
    Count: Cardinal;
    IndxDiscUM: Word;
    Priece: Cardinal;
    IndxDiscCurr: Word;
    IndxStr: Char;
    ProcMargin: Word;
    ProcDiscount: Word;
  end;
  PFiskalStr = ^TFiskalStr;

  //
  TSubTotal = record
    IndxDsicSubTotal: Word;
    DefineSubTotal: string[15];
    IndDiscCurr: Word;
    ProcMargin: Single;
    ProcDiscount: Single;
  end;
  PSubTotal = ^TSubTotal;

  TSubTotalAnswer = record
    TypeCheck: TTypeCheck;
    CountFStr: Word;
    TotalMarginTransl: Currency;
    TotalDiscountComiss: Currency;
    TotalContainer: Currency;
    InCashe: Currency;
  end;
  PSubTotalAnswer = ^TSubTotalAnswer;

  //
  // TFontPrn = (Bold, DblH, DblW, UndLine);

  //  
  TTypeDok = (ServiceDok, ServiceBackDok, PaymentDok, PaymentBackDok, CasheDok, CasheBackDok);
  PTypeDok = ^TTypeDok;

  TFDok = record
    TDok: TTypeDok;
    IndxDiscCurr: Word;
    CountFreeLine: Word;
    PosHeader1: Word;
    PosDisc: Word;
    LenDisc: Word;
    PosDefineDisc: Word;
    LenDefineDisc: Word;
    PosDiscStr: Word;
    LenDiscStr: Word;
    PosDefineStr: Word;
    LenDefgineDiscStr: Word;
    PosSum: Word;
    LenSum: Word;
    PosDiscTotal: Word;
    LenDiscTotal: Word;
    PosDefineTotal: Word;
    LenDefineToTal: Word;
    PosSumTotal: Word;
    LenSumTotal: Word;
    PosHeader2: Word;
  end;
  PFDok = ^TFDok;

  TTypeStrFDok = WideString;
  //  
  {
  TFDokStr = record
    IndxDisc: Word;
    DefineDesc: String;
    Count: Single;
    IndxDiscEI: Word;
    Price: Currency;
    IndxDiscCurr: Word;
    TypeStr: TTypeStrFDok;
    ProcMargine: Single;
    ProcDiscount: Single;
  end;
  PFDokStr = ^TFDokStr;
  }
  //  
  TSubTotalFDok = record
    PrintDok: Boolean;
    IndxDiscSubTotal: Word;
    DefineSubTotal: string;
    IndDiscCurr: Word;
    ProcMargine: Single;
    ProcDiscount: Single;
  end;
  PSubTotalFDok = ^TSubTotalFDok;

  // 
  TSubTotalDokAnswer = record
    TDok: TTypeDok;
    CountLine: Word;
    TotalSale: Currency;
    TotalMargine: Currency;
    TotalDiscount: Currency;
    TotalConteiner: Currency;
    InCashe: Currency;
  end;
  PSubTotalDokAnswer = ^TSubTotalDokAnswer;

  //  
  TPayment = (NotComplectDok, FullDok);
  TTotalFDok = record
    IndxDiscPayment: Word;
    DefinePayment: string;
    InCashe: Currency;
    IndxDiscCurr: Word;
    Payment: TPayment;
  end;
  PTotalFDok = ^TTotalFDok;

  TPrnStates = record
    psError,
      psOff,
      psLogLine,
      psCheckLine,
      psBuffFull,
      psBuffEmpty,
      psBeginDok,
      psEndDok,
      psDokSmall,
      psLineNo,
      psAllError: Boolean;
  end;
  PPrnStates = ^TPrnStates;

  TFiskalStates = record
    fsErrorFMem,
      fsErrorWMem,
      fsBattaryLow,
      fsUnknowCommand,
      fsErrorField,
      fsErrorCommand,
      fsOverTotal,
      fsFMemFull,
      fsFMemSoonFull,
      fsCertificated,
      fsFiskalited,
      fsErrorPassDate,
      fsDokCheckOpened,
      fsCheckOpened,
      fsDokOpened,
      fsAllError: Boolean;
  end;
  PFiskalStates = ^TFiskalStates;

  TStateRegistrator = record
    Printer: TPrnStates;
    Fiskal: TFiskalStates;
  end;

implementation

end.

